diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/Receiver.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/Receiver.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/Receiver.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/Receiver.java	2017-09-22 12:45:10.899756000 +0900
@@ -0,0 +1,1410 @@
+
+package com.android.server.remote;
+
+import java.io.BufferedWriter;
+import java.io.ByteArrayOutputStream;
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileNotFoundException;
+import java.io.FileOutputStream;
+import java.io.FileWriter;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.io.OutputStream;
+import java.lang.reflect.Field;
+import java.net.Socket;
+import java.nio.ByteBuffer;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.zip.DataFormatException;
+import java.util.zip.Inflater;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipInputStream;
+
+import android.app.Activity;
+import android.app.ActivityManager;
+import android.app.ActivityThread;
+import android.app.AlarmManager;
+import android.app.Instrumentation;
+import android.app.PackageInstallObserver;
+import android.app.PendingIntent;
+import android.content.ComponentName;
+import android.content.Context;
+import android.content.Intent;
+import android.content.pm.ApplicationInfo;
+import android.content.pm.IPackageManager;
+import android.content.pm.ManifestDigest;
+import android.content.pm.PackageInfo;
+import android.content.pm.PackageInstaller;
+import android.content.pm.PackageManager;
+import android.content.pm.PackageParser;
+import android.content.pm.PackageUserState;
+import android.content.pm.ResolveInfo;
+import android.content.pm.VerificationParams;
+import android.graphics.Bitmap;
+import android.graphics.BitmapFactory;
+import android.graphics.Canvas;
+import android.graphics.Paint;
+import android.graphics.Point;
+import android.hardware.input.IInputManager;
+import android.hardware.input.InputManager;
+import android.location.ILocationManager;
+import android.location.Location;
+import android.location.LocationManager;
+import android.media.AudioFormat;
+import android.media.AudioManager;
+import android.media.AudioTrack;
+import android.media.MediaCodec;
+import android.media.MediaFormat;
+import android.net.Uri;
+import android.os.Binder;
+import android.os.Bundle;
+import android.os.IVibratorService;
+import android.os.Message;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.os.SystemClock;
+import android.os.SystemVibrator;
+import android.os.Vibrator;
+import android.service.devicemanagement.Device;
+import android.service.remote.AppendingObjectOutputStream;
+import android.service.remote.IRemoteService;
+import android.service.remote.RemoteRequest;
+import android.service.samd.ISAMDService;
+import android.service.samd.SAMDMessage;
+import android.service.remote.SdPackage;
+//import android.support.v4.content.IntentCompat;
+import android.util.ArrayMap;
+import android.util.AndroidRuntimeException;
+import android.util.Log;
+import android.view.Display;
+import android.view.KeyEvent;
+import android.view.MotionEvent;
+import android.view.WindowManager;
+
+import com.android.server.pm.PackageManagerService;
+import com.android.server.samd.SAMDService;
+
+public class Receiver implements Runnable {
+    private static final String TAG = "Receiver";
+    //INSTALL APK
+    PackageManager mPm;
+    PackageInstaller mInstaller;
+    ApplicationInfo mAppInfo;
+    public static ApplicationInfo SAMDAppInfo;
+    PackageParser.Package parsed;
+    PackageInfo mPkgInfo;
+    ManifestDigest mPkgDigest;
+    public static Intent mLaunchIntent;
+    public static Context SAMDContext;
+
+    private final int INSTALL_COMPLETE = 1;
+
+    private Socket clientSocket;
+    private ObjectOutputStream outToClient;
+    private AppendingObjectOutputStream oos;
+    private ObjectInputStream inFromClient;
+    private int hashValue;
+    private int sourceDevice;
+
+    // private ObjectOutputStream
+    private final Context mContext;
+    private final String mPackageName;
+    private final IVibratorService mService;
+
+    private SystemVibrator mVibratorService;
+    private Vibrator mVibrator;
+
+    private final IInputManager mInputService;
+    private final Instrumentation mInstrumentation;
+    private final ILocationManager mLocationManager;
+    private final IRemoteService mRemoteService;
+
+    ////////////////////////////////////////////////////////
+    private MediaFormat format;
+    private MediaCodec codec;
+    private AudioTrack audioTrack;
+
+    // variables of format
+    private String mime = "";
+    private int sampleRate = 0, channels = 0, bitrate = 0;
+    private long duration = 0;
+    ByteBuffer[] codecInputBuffers;
+    ByteBuffer[] codecOutputBuffers;
+    // decode start
+    final long TIMEOUT_US = 5000;
+    MediaCodec.BufferInfo info = new MediaCodec.BufferInfo();
+    boolean sawInputEOS = false;
+    boolean sawOutputEOS = false;
+    int noOutputCounter = 0;
+    int noOutputCounterLimit = 10;
+    private int test = 0;
+
+    boolean stop = false;
+    long presentationTimeUs = 0;
+    int sampleSize = 0;
+    // /////////////////////////////////////////////
+
+    private int Xdefault;
+    private int Ydefault;
+
+    // private Object input = null;;
+    private Location location = new Location("");
+
+    // Native Functions
+    /*native void sendRemoteEvent(int type, int sensor, float[] values, int accuracy, long timestamp,
+            int sourceDevice);*/
+    public Receiver(Context context, Socket clientSocket, int _sourceDevice) {
+        mContext = context;
+        mPackageName = ActivityThread.currentPackageName();
+        mService = IVibratorService.Stub.asInterface(ServiceManager
+                .getService("vibrator"));
+
+        mVibratorService = new SystemVibrator(mContext);
+
+        mInputService = IInputManager.Stub.asInterface(ServiceManager.getService("input"));
+        mInstrumentation = new Instrumentation();
+
+        mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+
+        mRemoteService = IRemoteService.Stub.asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+
+        this.clientSocket = clientSocket;
+        hashValue = clientSocket.getInetAddress().getHostAddress().hashCode();
+        this.sourceDevice = _sourceDevice;
+
+        WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
+        Display display = wm.getDefaultDisplay();
+        Point size = new Point();
+        display.getSize(size);
+
+
+        Xdefault = size.x;
+        Ydefault = size.y;
+
+        Log.d(TAG, "request from: "
+                + this.clientSocket.getInetAddress().getHostAddress());
+
+        try {
+
+            outToClient = new ObjectOutputStream(this.clientSocket.getOutputStream());
+            oos = new AppendingObjectOutputStream(this.clientSocket.getOutputStream());
+            inFromClient = new ObjectInputStream(
+                    this.clientSocket.getInputStream());
+
+
+        } catch (IOException e) {
+            e.printStackTrace();
+        }
+    }
+
+    public void terminate() {
+
+    }
+
+    public void unzip(String _zipFile, String _targetLocation) {
+        //create target location folder if not exist
+        dirChecker(_targetLocation);
+        try {
+            FileInputStream fin = new FileInputStream(_zipFile);
+            ZipInputStream zin = new ZipInputStream(fin);
+            ZipEntry ze = null;
+            while ((ze = zin.getNextEntry()) != null) {
+
+                //create dir if required while unzipping
+                if (ze.isDirectory()) {
+                    dirChecker(ze.getName());
+                } else {
+                    FileOutputStream fout = new FileOutputStream(_targetLocation + ze.getName());
+                    for (int c = zin.read(); c != -1; c = zin.read()) {
+                        fout.write(c);
+                    }
+
+                    zin.closeEntry();
+                    fout.close();
+                }
+
+            }
+            zin.close();
+        } catch (Exception e) {
+            System.out.println(e);
+        }
+    }
+
+    private void dirChecker(String dir) {
+        File f = new File(dir);
+        if (!f.isDirectory()) {
+            f.mkdirs();
+        }
+    }
+
+
+    @Override
+    public void run() {
+        int ClientDeviceNum = 0;
+        // TODO Auto-generated method stub
+        try {
+            while (!Thread.currentThread().isInterrupted()) {
+                Object input = inFromClient.readObject();
+                // request for resources
+                if (input instanceof ResourceRequest) {
+                    // ask RemoteService whether this device is allowed for the resources
+                    ResourceRequest rr = (ResourceRequest) input;
+                    Log.d(TAG, "Requested: " + Arrays.toString(rr.getRequestedResources()));
+                    //client is [server output] add
+                    RemoteService.waitForResponse.put(clientSocket.getInetAddress().getHostAddress(), outToClient);
+                    oos.flush();
+                    mRemoteService.isAllowedForResource(rr.getDeviceName(), clientSocket.getInetAddress().getHostAddress(), rr.getRequestedResources());
+                    for (int i : rr.getRequestedResources()) {
+                        if (i == Device.RESOURCE_TYPE_REMOTE_ACTIVITY) {
+                            RemoteService.toRemoteActivityServer.add(oos);
+                            RemoteService.deviceToOutput.
+                                    put(this.clientSocket.getInetAddress().getHostAddress(), oos);
+                            Device d = new Device();
+                            SAMDService.cachedActivityResourceDevices.add(d);
+                            ArrayList<String> list = new ArrayList<String>();
+                            SAMDService.callActivityStackPerDevice.append(ClientDeviceNum++,list);
+                            Log.d(TAG, "SBJJJJJJJJJJJJJJJJJJJJJJJ");
+                            Log.d(TAG, "SBJJJJJJJJJJJJJJJJJJJJJJJ");
+                            Log.d(TAG, this.clientSocket.getInetAddress().getHostAddress() + "SBJJJJJJJJJJJ");
+                            Log.d(TAG, RemoteService.deviceToOutput.size() + "SBJJJJJJJJJJJJJJ");
+                            Log.d(TAG, "SBJJJJJJJJJJJJJJJJJJJJJJJ");
+                            Log.d(TAG, "SBJJJJJJJJJJJJJJJJJJJJJJJ");
+                        }
+                    }
+                    //outToClient.writeObject(test);
+                } else if (input instanceof String) {
+                    Log.d(TAG, "String: " + input.toString());
+                    if (input.toString().equals("Hello")) {
+                        Log.d(TAG, "just got Hellooo from client"
+                                + RemoteService.mSensorHandles.toString());
+                        Log.d(TAG, "SBJJJJJJJJJJJJJJJJJ");
+                        oos.writeObject("Gooooood");
+                        oos.flush();
+                        Log.d(TAG, "SBJJJJJJJJJJJJJJJJJ");
+                    }
+                } /*else if (input instanceof ResourceAapt) {
+                    final long origId = Binder.clearCallingIdentity();
+
+                    try{
+                        new aaptTask().execute((ResourceAapt) input);
+                    }finally {
+                        Binder.restoreCallingIdentity(origId);
+                    }
+                } else if (input instanceof DexCode) {
+                    final long origId = Binder.clearCallingIdentity();
+                    try{
+                        new dexTask().execute((DexCode) input);
+                    }finally {
+                        Binder.restoreCallingIdentity(origId);
+                    }
+                }*/ else if (input instanceof RemoteRequest) {
+                    RemoteRequest request = (RemoteRequest) input;
+
+                    Log.d(TAG, "Request: " + request.toString());
+
+                    // Handle Request Here!
+                    final long origId = Binder.clearCallingIdentity();
+
+                    try {
+                        if (request.getType().equalsIgnoreCase("systemcall")) {
+                            if (request.getMethod().compareTo("vibrate") == 0) {
+//                                Log.d(TAG, "vibrated" + sourceDevice);
+                                mVibrator = (Vibrator) mContext.getSystemService(Context.VIBRATOR_SERVICE);
+                                mVibrator.vibrate((Long) request.getPara().get(0));
+                                Log.d(TAG, "vibrated" + sourceDevice);
+//                                mVibratorService.vibrate((Long) request.getPara().get(0));
+                            } else if (request.getMethod().compareTo("vibrate2") == 0) {
+                                mVibrator = (Vibrator) mContext.getSystemService(Context.VIBRATOR_SERVICE);
+                                mVibrator.vibrate((long[]) request.getPara().get(0),
+                                        (Integer) request.getPara().get(1));
+//                                mVibratorService.vibrate((long[]) request.getPara().get(0),
+//                                                (Integer) request.getPara().get(1));
+                            }
+                        } else if (request.getType().equals("RemoteMusic")) {
+                            Log.d(TAG, "you are in RemoteRequest, in if RemoteMusic");
+                            RemoteRequest rr = (RemoteRequest) input;
+                            format = new MediaFormat();
+                            try {
+                                // format = MediaFormat.createAudioFormat(mime,
+                                // sampleRate,
+                                // channels);
+                                // format = ee.getTrackFormat(0);
+                                Log.d(TAG, "the mime is  "
+                                        + (String) rr.getPara().get(0));
+                                format.setString(MediaFormat.KEY_MIME,
+                                        mime = (String) rr.getPara().get(0));
+                                format.setInteger(MediaFormat.KEY_SAMPLE_RATE,
+                                        sampleRate = (Integer) rr.getPara()
+                                                .get(1));
+                                format.setInteger(
+                                        MediaFormat.KEY_CHANNEL_COUNT,
+                                        channels = (Integer) rr.getPara()
+                                                .get(2));
+                                format.setLong(MediaFormat.KEY_DURATION,
+                                        duration = (Long) rr.getPara().get(3));
+
+                            } catch (Exception e) {
+                                Log.e(TAG,
+                                        "Reading format parameters exception:"
+                                                + e.getMessage());
+                            }
+                            codec = MediaCodec.createDecoderByType("audio/mpeg");
+                            codec.configure(format, null, null, 0);
+                            codec.start();
+
+                            codecInputBuffers = codec.getInputBuffers();
+                            codecOutputBuffers = codec.getOutputBuffers();
+
+                            int channelConfiguration = 0;
+                            if (channels == 1)
+                                channelConfiguration = AudioFormat.CHANNEL_OUT_MONO;
+                            else
+                                channelConfiguration = AudioFormat.CHANNEL_OUT_STEREO;
+
+                            int minSize = AudioTrack.getMinBufferSize(sampleRate,
+                                    channelConfiguration,
+                                    AudioFormat.ENCODING_PCM_16BIT);
+                            audioTrack = new AudioTrack(AudioManager.STREAM_MUSIC,
+                                    sampleRate, channelConfiguration,
+                                    AudioFormat.ENCODING_PCM_16BIT, minSize,
+                                    AudioTrack.MODE_STREAM);
+                            // feeding
+                            audioTrack.play();
+
+                            Log.d(TAG, "the codec is waiting for you");
+                            test = 0;
+                        }
+                        // music stop
+                        else if (request.getType().equals("StopMusic")) {
+                            Log.d(TAG, "stopping...");
+
+                            if (codec != null) {
+                                codec.stop();
+                                codec.release();
+                                codec = null;
+                            }
+                            if (audioTrack != null) {
+                                audioTrack.flush();
+                                audioTrack.release();
+                                audioTrack = null;
+                            }
+                            Log.d(TAG, "music play is done");
+
+                        }
+
+                        // video streaming
+                        else if (request.getType().equalsIgnoreCase("video_streaming")) {
+                            Log.d(TAG, "11111111111");
+                            if (request.getMethod().equalsIgnoreCase("get_surface")) {
+                                Log.d(TAG, "2222222222");
+                                ComponentName compName = new ComponentName(
+                                        "com.example.surfaceprovider"
+                                        , "com.remote.surfaceprovider.SurfaceProvider");
+
+                                Intent intent = new Intent(Intent.ACTION_MAIN);
+                                intent.addCategory("android.intent.category.VIDEO_STREAMING");
+                                intent.setComponent(compName);
+                                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+
+                                int port = (Integer) request.getPara().get(1);
+                                Log.d(TAG, request.toString() + "  " + port);
+                                intent.putExtra("mode", "video");
+                                intent.putExtra("dcslab", port);
+                                mContext.startActivity(intent);
+
+                                // Intent intent =
+                                // context.getPackageManager().getLaunchIntentForPackage("ParkageName");
+                                // startActivity(intent);
+                            }
+                        } else if (request.getType().equalsIgnoreCase("request")) {
+                            if (request.getMethod().equalsIgnoreCase("motion")) {
+                                mRemoteService.connectToServer(clientSocket.getInetAddress().getHostAddress());
+                            } else if (request.getMethod().equalsIgnoreCase("dummyApp")) {
+                                Log.d(TAG, "HELLO");
+                                ComponentName compName = new ComponentName(
+                                        "com.example.surfaceprovider"
+                                        , "com.remote.surfaceprovider.SurfaceProvider");
+
+                                Intent intent = new Intent(Intent.ACTION_MAIN);
+                                intent.addCategory("android.intent.category.VIDEO_STREAMING");
+                                intent.setComponent(compName);
+                                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+
+                                intent.putExtra("mode", "dummyApp");
+
+                                mContext.startActivity(intent);
+                            }
+                        } else if (request.getType().equalsIgnoreCase("initializeAR")) {
+                            if (request.getMethod().equalsIgnoreCase("init")) {
+                                Log.d("uuuuuuu_initializeAR",
+                                        "s-----------------------------------------------------------------------------------------------");
+                                SAMDService.CURRENT_APP_NAME = (String) request.getPara().get(0);
+
+                                SAMDService.resourcesPerActivity.clear();
+                                //SAMDService.callActivityStack.clear();
+                                SAMDService.callResourceStack.clear();
+
+                                DeleteRecursiveFiles(new File("/collaboroid/agent/activity_res/"));
+                                DeleteRecursiveFiles(new File("/collaboroid/agent/dex/"));
+                                File f = new File("/collaboroid/agent/abc.apk");
+                                if(f.exists()){
+                                    f.delete();
+                                }
+
+                                oos.writeObject("init ok");
+                                oos.flush();
+
+                                Log.d("uuuuuuu_initializeAR", "SAMDService.CURRENT_APP_NAME : " + SAMDService.CURRENT_APP_NAME);
+
+                                Log.d("uuuuuuu_initializeAR",
+                                        "e-----------------------------------------------------------------------------------------------");
+                            }
+                        } else if (request.getType().equalsIgnoreCase("sendMessage")) {
+                            if (request.getMethod().equalsIgnoreCase("getMessageLR")) {
+                                //int(Player) && String(msg)
+                                try {
+                                    SAMDMessage message =
+                                            new SAMDMessage((int) request.getPara().get(0),
+                                                    SAMDService.remote_device_number,
+                                                    (String) request.getPara().get(1));
+                                    SAMDService.dispatchMessage(message);
+
+                                } catch (AndroidRuntimeException are) {
+                                    Log.d(TAG, "ERROR!!!");
+                                }
+                            }
+                            if (request.getMethod().equalsIgnoreCase("getMessageRL")) {
+
+                                SAMDMessage message =
+                                        new SAMDMessage((int) request.getPara().get(0),
+                                                0,
+                                                (String) request.getPara().get(1));
+
+                                message.setStime((long)request.getPara().get(2));
+
+                                SAMDService.dispatchMessage(message);
+
+                            }
+                        } else if (request.getType().equalsIgnoreCase("sendActivity")) {
+                            Log.d(TAG, "sendActivity!!!!!!");
+                            if (request.getMethod().equalsIgnoreCase("OnlyName")) {
+                                String activityName = (String) request.getPara().get(0);
+                                Log.d("samd experiment"," sendActivity/onlyname ["+activityName+"]");
+                                File f = new File("/collaboroid/agent/activity_res/"+activityName+"/abc.apk");
+                                if(!f.exists()){
+                                    SAMDService.callResourceStack.add(activityName);
+                                }else{
+                                    ISAMDService ss = ISAMDService.Stub.asInterface(ServiceManager.getService(Context.SAMD_SERVICE));
+                                    ss.popUpActivity(activityName);
+                                }
+                            }
+                            if (request.getMethod().equalsIgnoreCase("WithResource")) {
+                                Log.d("uuuuuuu_sendActivity/WithResource",
+                                        "s-----------------------------------------------------------------------------------------------");
+                                String activityName = (String) request.getPara().get(0);
+                                Log.d("samd experiment","[withResource]receive Dex & Resources : " + activityName);
+                                //PRE RESOURCES
+                                int preResourcesNum = (int) request.getPara().get(1);
+                                //REAL RESOURCES
+                                int resourcesNum = (int) request.getPara().get(2+preResourcesNum);
+                                ArrayList<String> addResourcesPerActivity = new ArrayList<String>();
+                                Log.d("uuuuuuu_sendActivity/WithResource", "preResourcesNum : " + preResourcesNum);
+                                for (int i = 0, j = 2; i < preResourcesNum; i++, j ++) {
+                                    Log.d("uuuuuuu_sendActivity/WithResource", "getResourcesLR pre receive : " + (String) request.getPara().get(j));
+                                    //SBJ_A/res/drawable/a.png?
+                                    String resDirectory = (String) request.getPara().get(j);
+                                    Log.d("uuuuuuu_sendActivity/WithResource","resDirectory : " + resDirectory);
+                                    //add resources
+                                    File src = new File("collaboroid/agent/activity_res/"+resDirectory);
+                                    String dstResDirectory = resDirectory.replace(resDirectory.split("\\/")[0],activityName);
+                                    Log.d("uuuuuuu_sendActivity/WithResource","dstResDirectory : " + dstResDirectory);
+                                    File dst = new File("collaboroid/agent/activity_res/"+dstResDirectory);
+                                    copy(src, dst);
+                                    addResourcesPerActivity.add(resDirectory);
+                                }
+                                Log.d("uuuuuuu_sendActivity/WithResource", "resourcesNum : " + resourcesNum);
+                                for (int i = 0, j = 2+preResourcesNum+1; i < resourcesNum; i++, j += 2) {
+                                    Log.d("uuuuuuu_sendActivity/WithResource", "getResourcesLR receive : " + (String) request.getPara().get(j));
+                                    String activityResDirectory = (String) request.getPara().get(j);
+                                    //add resources
+                                    addResourcesPerActivity.add(activityResDirectory);
+                                    //create directory
+                                    createDirAndFile(activityResDirectory,(byte[]) request.getPara().get(j + 1));
+                                }
+                                for(String s : addResourcesPerActivity){
+                                    Log.d("uuuuuuu_sendActivity/WithResource", "Resources Per Activity : : " + s);
+                                }
+                                AndroidManifestDummy(activityName);
+                                SAMDService.resourcesPerActivity.put(activityName, addResourcesPerActivity);
+
+                                for(int i=0; i<addResourcesPerActivity.size(); i++){
+                                    addResourcesPerActivity.set(i,
+                                            addResourcesPerActivity.get(i).replace(addResourcesPerActivity.get(i).split("\\/")[0]+"/assets/",""));
+                                }
+
+                                File f = new File("collaboroid/agent/activity_res/"+activityName+"/assets");
+                                if(f.exists()){
+                                    IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+                                    try {
+                                        pm.aaptPackageWithAssets("/collaboroid/agent/activity_res/"+activityName+"/res",
+                                                "collaboroid/agent/activity_res/"+activityName+"/assets",
+                                                "/collaboroid/agent/activity_res/"+activityName+"/AndroidManifest.xml",
+                                                "/collaboroid/agent/activity_res/"+activityName+"/abc.apk");
+                                    } catch (RemoteException e) {
+                                        e.printStackTrace();
+                                    }
+
+                                }else{
+                                    IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+                                    try {
+                                        pm.aaptPackage("/collaboroid/agent/activity_res/"+activityName+"/res",
+                                                "/collaboroid/agent/activity_res/"+activityName+"/AndroidManifest.xml",
+                                                "/collaboroid/agent/activity_res/"+activityName+"/abc.apk");
+                                    } catch (RemoteException e) {
+                                        e.printStackTrace();
+                                    }
+
+                                }
+
+                                File abcFile = new File("/collaboroid/agent/activity_res/"+activityName+"/abc.apk");
+                                File dst_f = new File("/collaboroid/agent/abc.apk");
+                                copy(abcFile, dst_f);
+
+                                IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+
+                                if (SAMDService.DUMMY_BIT) {
+                                    Log.d("samd experiment","aapt add/remove start["+activityName+"]");
+                                    pm.aaptAdd(2, "/system/priv-app/Dummy1/Dummy1.apk", "classes.dex");
+                                    File dexFile = new File("/collaboroid/agent/dex/" + activityName + "_classes.dex");
+                                    File classesDex = new File("/collaboroid/agent/dex/classes.dex");
+                                    dexFile.renameTo(classesDex);
+
+                                    pm.aaptAdd(1, "/system/priv-app/Dummy1/Dummy1.apk", "/collaboroid/agent/dex/classes.dex");
+                                    classesDex.renameTo(dexFile);
+
+                                    Log.d("samd experiment","aapt add/remove end["+activityName+"]");
+
+                                    ComponentName compName = new ComponentName(
+                                            "com.collaboroid.dummy1", "com.collaboroid.dummy1.MainActivity");
+
+                                    Intent intent = new Intent(Intent.ACTION_MAIN);
+                                    intent.setComponent(compName);
+
+                                    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+                                    intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);
+                                    intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
+
+                                    String resListarray[] = new String[addResourcesPerActivity.size()];
+                                    resListarray = addResourcesPerActivity.toArray(resListarray);
+                                    //resListarray[resListarray.length-1] = String.valueOf(SAMDService.remote_device_number);
+
+                                    intent.putExtra("SAWR", resListarray);
+
+                                    mContext.startActivity(intent);
+                                    SAMDService.DUMMY_BIT = !SAMDService.DUMMY_BIT;
+
+                                    ActivityManager activityManager = (ActivityManager) mContext.getSystemService(Context.ACTIVITY_SERVICE);
+                                    List<ActivityManager.RunningAppProcessInfo> pidsTask = activityManager.getRunningAppProcesses();
+
+                                    for (int i = 0; i < pidsTask.size(); i++) {
+                                        Log.d("SBJSBJ processName", "SBJSBJ processName : " + pidsTask.get(i).processName);
+                                        Log.d("SBJSBJ processName", "SBJSBJ uid : " + pidsTask.get(i).uid);
+                                        Log.d("SBJSBJ processName", "SBJSBJ pid : " + pidsTask.get(i).pid);
+                                        if (pidsTask.get(i).processName.equals("com.collaboroid.dummy2")) {
+                                            android.os.Process.killProcess(pidsTask.get(i).pid);
+                                        }
+                                    }
+
+                                } else {
+                                    Log.d("samd experiment","aapt add/remove start["+activityName+"]");
+                                    pm.aaptAdd(2, "/system/priv-app/Dummy2/Dummy2.apk", "classes.dex");
+                                    File dexFile = new File("/collaboroid/agent/dex/" + activityName + "_classes.dex");
+                                    File classesDex = new File("/collaboroid/agent/dex/classes.dex");
+                                    dexFile.renameTo(classesDex);
+                                    pm.aaptAdd(1, "/system/priv-app/Dummy2/Dummy2.apk", "/collaboroid/agent/dex/classes.dex");
+                                    classesDex.renameTo(dexFile);
+
+                                    Log.d("samd experiment","aapt add/remove end["+activityName+"]");
+
+                                    ComponentName compName = new ComponentName(
+                                            "com.collaboroid.dummy2", "com.collaboroid.dummy2.MainActivity");
+
+                                    Intent intent = new Intent(Intent.ACTION_MAIN);
+
+                                    intent.setComponent(compName);
+
+                                    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+                                    intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);
+                                    intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
+
+                                    String resListarray[] = new String[addResourcesPerActivity.size()];
+                                    resListarray = addResourcesPerActivity.toArray(resListarray);
+                                    //resListarray[resListarray.length-1] = String.valueOf(SAMDService.remote_device_number);
+                                    intent.putExtra("SAWR", resListarray);
+
+
+                                    mContext.startActivity(intent);
+                                    SAMDService.DUMMY_BIT = !SAMDService.DUMMY_BIT;
+
+                                    ActivityManager activityManager = (ActivityManager) mContext.getSystemService(Context.ACTIVITY_SERVICE);
+                                    List<ActivityManager.RunningAppProcessInfo> pidsTask = activityManager.getRunningAppProcesses();
+
+                                    for (int i = 0; i < pidsTask.size(); i++) {
+                                        Log.d("SBJSBJ processName", "SBJSBJ processName : " + pidsTask.get(i).processName);
+                                        Log.d("SBJSBJ processName", "SBJSBJ uid : " + pidsTask.get(i).uid);
+                                        Log.d("SBJSBJ processName", "SBJSBJ pid : " + pidsTask.get(i).pid);
+                                        if (pidsTask.get(i).processName.equals("com.collaboroid.dummy1")) {
+                                            android.os.Process.killProcess(pidsTask.get(i).pid);
+                                        }
+                                    }
+                                }
+
+                                Log.d("uuuuuuu_sendActivity/WithResource",
+                                        "e-----------------------------------------------------------------------------------------------");
+                            }
+                        }else if(request.getType().equalsIgnoreCase("ResourcesTransfer")){
+                            if(request.getMethod().equalsIgnoreCase("getResourcesRL")){
+                                int remoteDeviceNum = (int) request.getPara().get(0);
+                                Log.d("samd experiment","receive mosaic image from "+ remoteDeviceNum);
+                                String appName = (String) request.getPara().get(1);
+                                int resourcesNum = (int) request.getPara().get(2);
+                                for (int i = 0, j = 3; i < resourcesNum; i++, j ++) {
+                                    String activityResDirectory = (String) request.getPara().get(j);
+                                    String split[] = activityResDirectory.split("/");
+                                    String baseDir = "/data/collaboroid/preprocess/" + appName+"/";
+                                    for(int z=0; z<split.length-1; z++){
+                                        baseDir += split[z]+"/";
+                                        File directory = new File(baseDir);
+                                        if(!directory.exists()){
+                                            directory.mkdir();
+                                        }
+                                    }
+                                    try {
+                                        //activity res
+                                        File activityResFile = new File("/data/collaboroid/preprocess/" + appName +"/"+activityResDirectory);
+                                        FileOutputStream fileOutputStream = new FileOutputStream(activityResFile);
+                                        fileOutputStream.write((byte[])request.getPara().get(j+1));
+                                        fileOutputStream.flush();
+                                        fileOutputStream.close();
+                                    } catch (Exception e) {
+                                        e.printStackTrace();
+                                    }
+                                }
+                            }
+                        }else if (request.getType().equalsIgnoreCase("sendFile")) {
+                            if (request.getMethod().equalsIgnoreCase("getAPK")) {
+
+                                Log.d("sendFile/getAPK",
+                                        "s-----------------------------------------------------------------------------------------------");
+                                Log.d("samd experiment", "receive APK File");
+
+
+                                byte[] APKbyte = (byte[]) request.getPara().get(0);
+                                String dir = (String) request.getPara().get(1);
+                                String pathSplit[] = dir.split("/");
+                                File APKFile = new File(dir);
+
+                                //check directory
+                                //0.03 ~ 0.04 sec
+                                String baseDir = "/";
+                                String permission = "777";
+                                for (int z = 1; z < pathSplit.length; z++) {
+                                    if(!pathSplit[z].contains(".apk")){
+                                        baseDir += pathSplit[z] +"/";
+                                        File directory = new File(baseDir);
+                                        if (!directory.exists()) {
+                                            directory.mkdir();
+                                        }
+                                    }else{
+                                        baseDir += pathSplit[z];
+                                        //0.01sec
+                                        FileOutputStream fileOutputStream = new FileOutputStream(APKFile);
+                                        fileOutputStream.write(APKbyte);
+                                        fileOutputStream.flush();
+                                        fileOutputStream.close();
+                                    }
+                                    
+                                    try {
+                                        String command = "chmod " + permission + " " + baseDir;
+                                        Runtime runtime = Runtime.getRuntime();
+                                        runtime.exec(command);
+                                    } catch (IOException e) {
+                                        e.printStackTrace();
+                                    }
+
+                                }
+
+                                Thread.sleep(3000);
+
+//                                final ApplicationManager am = new ApplicationManager(mContext);
+//                                am.setOnInstalledPackaged(new OnInstalledPackaged() {
+//                                    public void packageInstalled(String packageName, int returnCode) {
+//                                        if(returnCode == ApplicationManager.INSTALL_SUCCEEDED)
+//                                        {
+//                                            Log.d("samd experiment", "Install succeeded");
+//                                            Log.d("sendFile/getAPK",
+//                                                    "e-----------------------------------------------------------------------------------------------");
+//
+//                                            ComponentName compName = new ComponentName(
+//                                                    packageName, packageName+".SBJ_A");
+//
+//                                            Intent intent = new Intent(Intent.ACTION_MAIN);
+//
+//                                            intent.setComponent(compName);
+//
+//                                            intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+//                                            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);
+//                                            intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
+//
+//                                            mContext.startActivity(intent);
+//                                        }else{
+//                                            Log.d("samd experiment", "Install failed: " + returnCode);
+//                                        }
+//                                    }
+//                                });
+//
+//                                Log.d("samd experiment",
+//                                        "APK file Install ["
+//                                                +
+//                                                dir.split("/")[dir.split("/").length-1] + "] start");
+//                                try {
+//                                    am.installPackage(dir);
+//                                } catch (Exception e) {
+//                                    e.printStackTrace();
+//                                }
+
+                            }
+                        }
+                    } finally {
+                        Binder.restoreCallingIdentity(origId);
+                    }
+                } else if (input instanceof RemoteMotionEvent) {
+                    // MotionEvent event = (MotionEvent)input;
+                    RemoteMotionEvent rme = (RemoteMotionEvent) input;
+
+                    // Log.d(TAG, "RemoteMotionEvent: " + rme.toString());
+
+                    /*
+                     * MotionEvent event = MotionEvent.obtain(
+                     * SystemClock.uptimeMillis(), SystemClock.uptimeMillis(),
+                     * rme.getAction(), rme.getX() *
+                     * RemoteRequestHandler.Xdefault, rme.getY() *
+                     * RemoteRequestHandler.Ydefault, 0);
+                     */
+                    /*
+                     * MotionEvent event = MotionEvent.obtain(rme.getDownTime(),
+                     * rme.getEventTime(), rme.getAction(), rme.getX()
+                     * RemoteRequestHandler.Xdefault, rme.getY()
+                     * RemoteRequestHandler.Ydefault, 0);
+                     * event.setSource(rme.getSource());
+                     */
+
+                    MotionEvent event = MotionEvent.obtain(
+                            SystemClock.uptimeMillis(),
+                            SystemClock.uptimeMillis(),
+                            rme.getAction(),
+                            rme.getX() * Xdefault,
+                            rme.getY() * Ydefault, sourceDevice << 24);
+
+                    event.setSource(rme.getSource());
+
+                    /*Log.d(TAG, "Node: " + sourceDevice);
+                    MotionEvent event;
+                    if (sourceDevice != 1) {
+                        event = MotionEvent.obtain(SystemClock.uptimeMillis(),
+                                SystemClock.uptimeMillis(), rme.getAction(), 500, 500, 0);
+                        event.setSource(rme.getSource());
+                    }
+                    else {
+                        event = MotionEvent.obtain(
+                                SystemClock.uptimeMillis(),
+                                SystemClock.uptimeMillis(),
+                                (rme.getAction() + (sourceDevice << 24)),
+                                rme.getX() * RemoteRequestHandler.Xdefault,
+                                rme.getY() * RemoteRequestHandler.Ydefault, 0);
+
+                        event.setSource(rme.getSource());
+                    }*/
+                    try {
+                        if (!mInputService.injectInputEvent(event,
+                                InputManager.INJECT_INPUT_EVENT_MODE_WAIT_FOR_RESULT)) {
+                            Log.d(TAG, "FAIL!!!!!");
+                        }
+                    } finally {
+                        event.recycle();
+                    }
+                }
+                /*
+                 * else if(input instanceof RemoteKeyEvent) { }
+                 */
+
+                else if (input instanceof RemoteKeyEvent) {
+                    RemoteKeyEvent rke = (RemoteKeyEvent) input;
+                    // Log.d(TAG, rke.toString());
+
+                    mInstrumentation.sendKeyDownUpSync(rke.getCode());
+                    if (rke.getAction() == KeyEvent.ACTION_DOWN) {
+                        Log.d("KeyLatency", "KeyLatency - server: " + sourceDevice);
+                    }
+                    /*
+                     * KeyEvent event = new KeyEvent(rke.getAction(),
+                     * rke.getCode()); event.setSource(rke.getSource()); try {
+                     * if (!mInputService.injectInputEvent(event,
+                     * InputManager.INJECT_INPUT_EVENT_MODE_ASYNC)) { Log.d(TAG,
+                     * "FAIL!!!!!"); } } finally { event.recycle(); }
+                     */
+                } else if (input instanceof RemoteSensorEvent) {
+                    RemoteSensorEvent rse = (RemoteSensorEvent) input;
+
+                    /*if(rse.getType() == Sensor.TYPE_PROXIMITY)
+                    	sendRemoteEvent(21, 21, rse.getValues(),
+                                rse.getAccuracy(),
+                                rse.getTimestamp(),
+                                sourceDevice);
+                    else
+                    	sendRemoteEvent(rse.getType(),
+                    		RemoteService.mSensorHandles.get(rse.getType()),
+                    		rse.getValues(),
+                    		rse.getAccuracy(),
+                    		rse.getTimestamp(),
+                    		sourceDevice);*/
+                } else if (input instanceof SdPackage) {
+                    // Log.d(TAG,
+                    // "music play start from request handler (SdPackage)");
+                    noOutputCounter++;
+                    // read a buffer before feeding it to the decoder
+                    if (!sawInputEOS) {
+                        int inputBufIndex = codec.dequeueInputBuffer(TIMEOUT_US);
+                        if (inputBufIndex >= 0) {
+                            ByteBuffer dstBuf = codecInputBuffers[inputBufIndex];
+
+                            SdPackage sdp = (SdPackage) input;
+                            // Log.i(TAG, sdp.toString());
+
+                            sampleSize = sdp.getSampleSize();
+                            byte[] temp_bytearray = new byte[sampleSize];
+                            temp_bytearray = sdp.getSampleData();
+                            // Log.i(TAG, Arrays.toString(temp_bytearray));
+                            dstBuf.clear();
+                            // dstBuf = ByteBuffer.wrap(temp_bytearray);
+                            dstBuf.put(temp_bytearray);
+                            presentationTimeUs = sdp.getPresentationTime();
+
+                            codec.queueInputBuffer(inputBufIndex, 0,
+                                    sampleSize, presentationTimeUs, 0);
+
+                            // Log.d(TAG, "client: queued to inputbuffer " +
+                            // inputBufIndex);
+                            // if (!sawInputEOS) //remote
+                            // extractor.advance(); //remote
+
+                        } else {
+                            // Log.e(TAG, "client: inputBufIndex " +
+                            // inputBufIndex);
+                        }
+                    } // !sawInputEOS
+
+                    // ///////////////////////////////////////////////////////
+                    // MediaCodecInfo df = codec.getCodecInfo();
+                    // byte[] dddd = new byte[8192];
+                    // for(int i=0;i<codecInputBuffers.length;i++){
+                    // for(int j=0;j<codecInputBuffers[i].limit();j++){
+                    // dddd[j] = codecInputBuffers[i].get(j);
+                    // }
+                    // Log.d("debugging", Arrays.toString(dddd));
+                    // }
+
+                    // /////////////////////////////////////////////////////
+
+                    // for (int i = 0; i < codecOutputBuffers.length; i++) {
+                    // Log.d(TAG, String.valueOf(codecOutputBuffers[i]
+                    // .remaining()));
+                    // }
+
+                    // decode to PCM and push it to the AudioTrack player
+                    int res = codec.dequeueOutputBuffer(info, 5000);
+
+                    if (res >= 0) {
+                        int outputBufIndex = res;
+                        ByteBuffer buf = codecOutputBuffers[outputBufIndex];
+                        // ByteBuffer buf =
+                        // codec.getOutputBuffer(outputBufIndex);
+
+                        final byte[] chunk = new byte[info.size];
+                        buf.get(chunk);
+                        buf.clear();
+                        if (chunk.length > 0) {
+                            audioTrack.write(chunk, 0, chunk.length);
+                        }
+
+                        codec.releaseOutputBuffer(outputBufIndex, false);
+
+                        if ((info.flags & MediaCodec.BUFFER_FLAG_END_OF_STREAM) != 0) {
+                            Log.d(TAG, "saw output EOS.");
+                            sawOutputEOS = true;
+                        }
+                    } else if (res == MediaCodec.INFO_OUTPUT_BUFFERS_CHANGED) {
+                        Log.d(TAG,
+                                "oh! information of output buffer has been changed");
+                        codecOutputBuffers = codec.getOutputBuffers();
+                        Log.d(TAG, "output buffers have changed.");
+                    } else if (res == MediaCodec.INFO_OUTPUT_FORMAT_CHANGED) {
+                        Log.d(TAG, "oh! the output format changed!");
+                        MediaFormat oformat = codec.getOutputFormat();
+                        Log.d(TAG, "output format has changed to "
+                                + oformat);
+                    } else {
+                        Log.d(TAG, "dequeueOutputBuffer returned " + res);
+                    }
+
+                    // Log.d("TAG", String.valueOf(noOutputCounter));
+
+                } else if (input instanceof RemoteLocation) {
+                    RemoteLocation RL = (RemoteLocation) input;
+
+                    location = new Location("");
+
+                    // location.reset();
+                    // location.setProvider(RL.getProvider());
+                    location.setProvider(LocationManager.REMOTE_PROVIDER);
+                    // location.setTime(RL.getTime());
+                    location.setTime(System.currentTimeMillis());
+                    // location.setElapsedRealtimeNanos(RL.getElapsedRealtimeNanos());
+                    location.setElapsedRealtimeNanos(SystemClock.elapsedRealtimeNanos());
+                    location.setLatitude(RL.getLatitude());
+                    location.setLongitude(RL.getLongitude());
+
+                    if (RL.getAltitude() != 0.0f)
+                        location.setAltitude(RL.getAltitude());
+                    if (RL.getSpeed() != 0.0f)
+                        location.setSpeed(RL.getSpeed());
+                    if (RL.getBearing() != 0.0f)
+                        location.setBearing(RL.getBearing());
+                    if (RL.getAccuracy() != 0.0f)
+                        location.setAccuracy(RL.getAccuracy());
+
+                    location.setExtras(RL.getExtras());
+                    location.setIsFromMockProvider(RL.isFromMockProvider());
+
+                    if (location.getExtras() != null)
+                        location.getExtras().putInt("SourceDevice", sourceDevice);
+                    else {
+                        Bundle bundle = new Bundle();
+                        bundle.putInt("SourceDevice", sourceDevice);
+                        location.setExtras(bundle);
+                    }
+
+                    mLocationManager.reportLocation(location, false);
+                } else
+                    Log.d(TAG, "What is this??");
+
+                // input.
+            }
+
+            clientSocket.close();
+            inFromClient.close();
+            outToClient.close();
+
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+    }
+
+    public PackageParser.Package getPackageInfo(File sourceFile) {
+        final PackageParser parser = new PackageParser();
+        try {
+            PackageParser.Package pkg = parser.parseMonolithicPackage(sourceFile, 0);
+            parser.collectManifestDigest(pkg);
+            return pkg;
+        } catch (PackageParser.PackageParserException e) {
+            return null;
+        }
+    }
+
+    public Intent apkInstall(Uri apkUri, File APKFile) {
+        boolean enabled = false;
+        //apk Install Process
+        mPm = mContext.getPackageManager();
+        mInstaller = mPm.getPackageInstaller();
+        parsed = getPackageInfo(APKFile);
+
+        mPkgInfo = PackageParser.generatePackageInfo(parsed, null,
+                PackageManager.GET_PERMISSIONS, 0, 0, null,
+                new PackageUserState());
+        mPkgDigest = parsed.manifestDigest;
+        String pkgName = mPkgInfo.packageName;
+        // Check if there is already a package on the device with this name
+        // but it has been renamed to something else.
+        String[] oldName = mPm.canonicalToCurrentPackageNames(new String[]{pkgName});
+        if (oldName != null && oldName.length > 0 && oldName[0] != null) {
+            pkgName = oldName[0];
+            mPkgInfo.packageName = pkgName;
+            mPkgInfo.applicationInfo.packageName = pkgName;
+        }
+        try {
+            // This is a little convoluted because we want to get all uninstalled
+            // apps, but this may include apps with just data, and if it is just
+            // data we still want to count it as "installed".
+            mAppInfo = mPm.getApplicationInfo(pkgName,
+                    PackageManager.GET_UNINSTALLED_PACKAGES);
+            if ((mAppInfo.flags & ApplicationInfo.FLAG_INSTALLED) == 0) {
+                mAppInfo = null;
+            }
+        } catch (PackageManager.NameNotFoundException e) {
+            mAppInfo = null;
+        }
+
+        String installerPackageName = null;
+        //installerPackageName is null
+
+        Uri originatingURI = apkUri;
+        //exist
+
+        int originatingUid = 1000;
+
+        ManifestDigest manifestDigest = mPkgDigest;
+        //exist
+
+        VerificationParams verificationParams = new VerificationParams(null, originatingURI,
+                null, originatingUid, manifestDigest);
+        int installFlags = 0;
+        try {
+            PackageInfo pi = mPm.getPackageInfo(mAppInfo.packageName,
+                    PackageManager.GET_UNINSTALLED_PACKAGES);
+            if (pi != null) {
+                installFlags |= PackageManager.INSTALL_REPLACE_EXISTING;
+            }
+        } catch (PackageManager.NameNotFoundException e) {
+        }
+        if ((installFlags & PackageManager.INSTALL_REPLACE_EXISTING) != 0) {
+            Log.w(TAG, "Replacing package:" + mAppInfo.packageName);
+        }
+
+
+        PackageInstallObserver observer = new PackageInstallObserver();
+
+        mPm.installPackageWithVerificationAndEncryption(apkUri, observer, installFlags,
+                installerPackageName, verificationParams, null);
+        //2th observer = nulls
+        //but is not confident
+
+        mLaunchIntent = mContext.getPackageManager().getLaunchIntentForPackage(
+                mAppInfo.packageName);
+
+        if (mLaunchIntent != null) {
+            List<ResolveInfo> list = mContext.getPackageManager().
+                    queryIntentActivities(mLaunchIntent, 0);
+            if (list != null && list.size() > 0) {
+                enabled = true;
+            }
+        }
+        return mLaunchIntent;
+    }
+
+    public Activity getActivity() {
+        Activity activity = null;
+        try {
+            Class activityThreadClass = Class.forName("android.app.ActivityThread");
+            Object activityThread = activityThreadClass.getMethod("currentActivityThread").invoke(null);
+            Field activitiesField = activityThreadClass.getDeclaredField("mActivities");
+            activitiesField.setAccessible(true);
+            ArrayMap activities = (ArrayMap) activitiesField.get(activityThread);
+            for (Object activityRecord : activities.values()) {
+                Class activityRecordClass = activityRecord.getClass();
+                Field pausedField = activityRecordClass.getDeclaredField("paused");
+                pausedField.setAccessible(true);
+                if (!pausedField.getBoolean(activityRecord)) {
+                    Field activityField = activityRecordClass.getDeclaredField("activity");
+                    activityField.setAccessible(true);
+                    activity = (Activity) activityField.get(activityRecord);
+
+                }
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+        return activity;
+    }
+
+    public void restart(Context context, int delay) {
+        if (delay == 0) {
+            delay = 1;
+        }
+        Log.d("SBJSBJ restart", "SBJSBJ retart");
+        Intent restartIntent = context.getPackageManager().getLaunchIntentForPackage(context.getPackageName());
+        PendingIntent intent = PendingIntent.getActivity(context, 0, restartIntent, Intent.FLAG_ACTIVITY_CLEAR_TOP);
+        AlarmManager manager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
+        manager.set(AlarmManager.RTC, System.currentTimeMillis() + delay, intent);
+        System.exit(2);
+    }
+
+    public static boolean saveBitmaptoJpeg(Bitmap bitmap, String folder, String name) {
+        String ex_storage = "collaboroid/preprocess/MosaicApp/";
+        // Get Absolute Path in External Sdcard
+        String foler_name = "/" + folder + "/";
+        String file_name = name + ".jpg";
+        String string_path = ex_storage + foler_name;
+
+        File file_path;
+        try {
+            file_path = new File(string_path);
+            if (!file_path.isDirectory()) {
+                file_path.mkdirs();
+            }
+            FileOutputStream out = new FileOutputStream(string_path + file_name);
+
+            bitmap.compress(Bitmap.CompressFormat.JPEG, 90, out);
+
+            out.close();
+
+        } catch (FileNotFoundException exception) {
+            Log.e("FileNotFoundException", exception.getMessage());
+        } catch (IOException exception) {
+            Log.e("IOException", exception.getMessage());
+        }
+
+        return true;
+    }
+
+    private Bitmap combineImage(Bitmap first, Bitmap second, boolean isVerticalMode) {
+        BitmapFactory.Options option = new BitmapFactory.Options();
+        option.inDither = true;
+        option.inPurgeable = true;
+        Bitmap bitmap = null;
+        if (isVerticalMode)
+            bitmap = Bitmap.createScaledBitmap(first, first.getWidth(), first.getHeight() + second.getHeight(), true);
+        else
+            bitmap = Bitmap.createScaledBitmap(first, first.getWidth() + second.getWidth(), first.getHeight(), true);
+        Paint p = new Paint();
+        p.setDither(true);
+        p.setFlags(Paint.ANTI_ALIAS_FLAG);
+        Canvas c = new Canvas(bitmap);
+        c.drawBitmap(first, 0, 0, p);
+        if (isVerticalMode)
+            c.drawBitmap(second, 0, first.getHeight(), p);
+        else
+            c.drawBitmap(second, first.getWidth(), 0, p);
+        first.recycle();
+        second.recycle();
+        return bitmap;
+    }
+
+    public byte[] bitmapToByteArray(Bitmap $bitmap) {
+        ByteArrayOutputStream stream = new ByteArrayOutputStream();
+        $bitmap.compress(Bitmap.CompressFormat.JPEG, 90, stream);
+        byte[] byteArray = stream.toByteArray();
+        return byteArray;
+    }
+
+    public Bitmap byteArrayToBitmap(byte[] $byteArray) {
+        Bitmap bitmap = BitmapFactory.decodeByteArray($byteArray, 0, $byteArray.length);
+        return bitmap;
+    }
+
+    private Bitmap decodeFile(File f) {
+        try {
+            BitmapFactory.Options o = new BitmapFactory.Options();
+            o.inJustDecodeBounds = true;
+            BitmapFactory.decodeStream(new FileInputStream(f), null, o);
+
+            final int REQUIRED_SIZE = 70;
+
+            int scale = 1;
+            while (o.outWidth / scale / 2 >= REQUIRED_SIZE &&
+                    o.outHeight / scale / 2 >= REQUIRED_SIZE) {
+                scale *= 2;
+            }
+
+            BitmapFactory.Options o2 = new BitmapFactory.Options();
+            o2.inSampleSize = scale;
+            return BitmapFactory.decodeStream(new FileInputStream(f), null, o2).copy(Bitmap.Config.ARGB_8888, true);
+        } catch (FileNotFoundException e) {
+        }
+        return null;
+    }
+
+    private byte[] decompress(byte[] data) throws IOException, DataFormatException {
+        Inflater inflater = new Inflater();
+        inflater.setInput(data);
+
+        ByteArrayOutputStream outputStream = new ByteArrayOutputStream(data.length);
+        byte[] buffer = new byte[4096];
+        while (!inflater.finished()) {
+            int count = inflater.inflate(buffer);
+            outputStream.write(buffer, 0, count);
+        }
+        outputStream.close();
+        byte[] output = outputStream.toByteArray();
+
+        inflater.end();
+
+        Log.d("mosaic_distribute", "Original : " + data.length);
+        Log.d("mosaic_distribute", "UnCompressed : " + output.length);
+
+        return output;
+    }
+
+    private void DeleteRecursiveFiles(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                DeleteRecursive(child);
+
+    }
+
+    private void DeleteRecursive(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                DeleteRecursive(child);
+
+        fileOrDirectory.delete();
+
+    }
+
+    private void DeleteRecursiveFilesNotFolder(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                DeleteRecursiveNotFolder(child);
+
+    }
+
+    private void DeleteRecursiveNotFolder(File fileOrDirectory) {
+        if (fileOrDirectory.isDirectory()) {
+            for (File child : fileOrDirectory.listFiles())
+                DeleteRecursive(child);
+        } else {
+            fileOrDirectory.delete();
+        }
+    }
+
+    public static void LaunchInstalledAPK(Message msg) {
+        final int INSTALL_COMPLETE = 1;
+        Log.d("install apk", "LaunchInstalledAPK msg.what : " + msg.what);
+        Log.d("install apk", "LaunchInstalledAPK msg.arg1 : " + msg.arg1);
+        switch (msg.what) {
+            case INSTALL_COMPLETE:
+                if (msg.arg1 == PackageManager.INSTALL_SUCCEEDED) {
+                    Log.d("install apk", "LaunchInstalledAPK PackageManagerService.SAMDMessage.arg1 : " +
+                            PackageManagerService.SAMDMessage.arg1);
+                    mLaunchIntent = SAMDContext.
+                            getPackageManager().
+                            getLaunchIntentForPackage(
+                                    SAMDAppInfo.packageName);
+                    boolean enabled = false;
+                    if (mLaunchIntent != null) {
+                        List<ResolveInfo> list = SAMDContext.
+                                getPackageManager().
+                                queryIntentActivities(mLaunchIntent, 0);
+                        if (list != null && list.size() > 0) {
+                            enabled = true;
+                        }
+                    }
+                    if (enabled) {
+                        //설치완료되면 button 활성화
+                        Log.d("install apk", "enabled is true");
+                        mLaunchIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+                        mLaunchIntent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);
+                        mLaunchIntent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
+                        SAMDContext.startActivity(mLaunchIntent);
+                    }
+                }
+        }
+
+    }
+
+    public void copy(File src, File dst) throws IOException{
+        InputStream in = new FileInputStream(src);
+        try{
+            OutputStream out = new FileOutputStream(dst);
+            try{
+                byte[] buf = new byte[4096];
+                int len;
+                while( (len=in.read(buf)) > 0){
+                    out.write(buf, 0, len);
+                }
+            }finally {
+                out.close();
+
+            }
+        }finally {
+            in.close();
+        }
+    }
+    public void createDirAndFile(String dir, byte[] dexByte){
+        String pathSplit[] = dir.split("/");
+        String baseDir = "/collaboroid/agent/activity_res/";
+        for (int z = 0; z < pathSplit.length; z++) {
+            if(pathSplit[z].contains(".png") || pathSplit[z].contains(".xml")
+                    || pathSplit[z].contains(".jpg") || pathSplit[z].contains(".jpeg")){
+                baseDir += pathSplit[z];
+                File activityResFile = new File("/collaboroid/agent/activity_res/" + dir);
+                try {
+                    //activity res
+                    FileOutputStream fileOutputStream = new FileOutputStream(activityResFile);
+                    fileOutputStream.write(dexByte);
+                    fileOutputStream.flush();
+                    fileOutputStream.close();
+                } catch (Exception e) {
+                    e.printStackTrace();
+                }
+            }else{
+                baseDir += pathSplit[z] +"/";
+                File directory = new File(baseDir);
+                if (!directory.exists()) {
+                    directory.mkdir();
+                }
+            }
+            Log.d("uuuuuuu_DexCode", "baseDir : : " + baseDir);
+        }
+    }
+    public void AndroidManifestDummy(String dexName) {
+        String[] DummyxmlLine =
+                {"<?xml version=\"1.0\" encoding=\"utf-8\"?>",
+                        "<manifest xmlns:android=\"http://schemas.android.com/apk/res/android\"",
+                        "package=\"com.collaboroid.dummy1\">",
+                        "android:versionCode=\"1\"",
+                        "android:versionName=\"1.0\"",
+                        "<uses-permission android:name=\"android.permission.INTERNET\"/>",
+                        "<uses-permission android:name=\"android.permission.KILL_BACKGROUND_PROCESSES\"/>",
+                        "<application",
+                        "android:icon=\"@drawable/ic_launcher\"",
+                        "android:label=\"@string/Main_title\">",
+                        "<activity android:name=\".MainActivity\"",
+                        "android:label=\"@string/Main_title\"",
+                        "android:launchMode=\"singleTask\"",
+                        "android:clearTaskOnLaunch=\"true\">",
+                        "<intent-filter>",
+                        "<action android:name=\"android.intent.action.MAIN\" />",
+                        "<category android:name=\"android.intent.category.LAUNCHER\" />",
+                        "</intent-filter>",
+                        "</activity>",
+                        "</application>",
+                        "</manifest>"};
+        String dummy1FileName = "/collaboroid/agent/activity_res/"+dexName+"/AndroidManifest.xml";
+        BufferedWriter bw = null;
+        try {
+            bw = new BufferedWriter(new FileWriter(dummy1FileName));
+            for(int i=0; i<DummyxmlLine.length; i++){
+                bw.write(DummyxmlLine[i]);
+                bw.newLine();
+
+            }
+        } catch (IOException e) {
+            e.printStackTrace();
+        } finally{
+            try {
+                if (bw != null)
+                    bw.close();
+            } catch (IOException e) {
+
+            }
+        }
+    }
+
+}
